#include <camera.h>
#include <iostream>
#include <glm/gtc/matrix_transform.hpp>

CameraArcball::CameraArcball(){}

void CameraArcball::initialize(int _width, int _height, glm::vec3 _center, float _radius)
{
	width = _width;
	height = _height;
	radius = _radius;
	fov = 45.0f;
	nearPlane = 0.1f;
	farPlane = radius*10.0f;
	viewMatrixID = projectionMatrixID = 0;

	//1-initialize center (do not pay attention to _center and _radius for now)
	center = _center;
	//2-initialize position
	position = center + glm::vec3(0.0,0.0,radius*3.0f);

	//Initial rotation
	rotation = glm::vec3();
	//Initial translation
	translation = -(position-center);

	//TODO - initialize view and projection matrices

}

CameraArcball::~CameraArcball(){}

void CameraArcball::rotateX(float angle)
{
	rotation[0] += angle;
}

void CameraArcball::rotateY(float angle)
{
	rotation[1] += angle;
}

void CameraArcball::translateX(float delta)
{
	translation[0] += delta;
}

void CameraArcball::translateY(float delta)
{
	translation[1] += delta;
}

void CameraArcball::update()
{
	//TODO
}
